<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: Matrix.hh Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_matrix_8hh_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Matrix.hh</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_matrix_8hh.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;cmath&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vector_8hh.html">Vector.hh</a>&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno"><a class="line" href="_matrix_8hh.html#a952eac791b596a61bba0a133a3bb439f">    8</a></span>&#160;<span class="keyword">const</span> <span class="keywordtype">double</span> <a class="code" href="_matrix_8hh.html#a952eac791b596a61bba0a133a3bb439f">PI</a> = 3.14159265;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">using</span> std::abs;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_matrix.html">   23</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_matrix.html">Matrix</a> {</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;  <span class="keyword">private</span>:</div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="class_matrix.html#ab20a4e5f5647febc866fb32744f54f86">   25</a></span>&#160;    T <a class="code" href="class_matrix.html#ab20a4e5f5647febc866fb32744f54f86">matrix</a>[SIZE][SIZE]{};</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_matrix.html#a4722df35d85e6bb1ac4666cd36063e52">SwitchRows</a>(<a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> &amp;matrix1) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_matrix.html#af127708865eb29c4157be68d2d783b65">GaussElimination</a>(<a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> &amp;matrix1) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="keyword">public</span>:</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    T &amp;<a class="code" href="class_matrix.html#a8d88b4b485a4716a41159891584b0870">operator()</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> column);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keyword">const</span> T &amp;<a class="code" href="class_matrix.html#a8d88b4b485a4716a41159891584b0870">operator()</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> column) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    T <a class="code" href="class_matrix.html#ac2c8303fdc06fd4c7e292455eae5c416">Determinant</a>(<a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> tmp) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_matrix.html#ad5c9497d13380b10beaff841f7f5216f">Transpose</a>();</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <a class="code" href="class_vector.html">Vector&lt;T, SIZE&gt;</a> <a class="code" href="class_matrix.html#aa32da33cf90c74d4a8083a08a3bf1001">operator*</a>(<span class="keyword">const</span> <a class="code" href="class_vector.html">Vector&lt;T, SIZE&gt;</a> &amp;vector) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="class_matrix.html#a3e08e51548e9fc339d66dcec03064d59">Matrix</a>();</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;};</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;std::istream &amp;<a class="code" href="_matrix_8hh.html#af58002b74adf2bdf4ee57cffba15ff6f">operator&gt;&gt;</a>(std::istream &amp;strm, <a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> &amp;matrix);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;std::ostream &amp;<a class="code" href="_matrix_8hh.html#a329c19028ad74b9c0a93102cfecfe445">operator&lt;&lt;</a>(std::ostream &amp;strm, <span class="keyword">const</span> <a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> &amp;matrix);</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="class_matrix.html#a8d88b4b485a4716a41159891584b0870">  113</a></span>&#160;T &amp;<a class="code" href="class_matrix.html#a8d88b4b485a4716a41159891584b0870">Matrix&lt;T, SIZE&gt;::operator()</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> column) {</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">const_cast&lt;</span>T &amp;<span class="keyword">&gt;</span>(<span class="keyword">const_cast&lt;</span><span class="keyword">const </span><a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> *<span class="keyword">&gt;</span>(<span class="keyword">this</span>)-&gt;<span class="keyword">operator</span>()(row, column));</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;}</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="class_matrix.html#a7b6c9a81b3ce322779c80af86eaa1eb4">  118</a></span>&#160;<span class="keyword">const</span> T &amp;<a class="code" href="class_matrix.html#a8d88b4b485a4716a41159891584b0870">Matrix&lt;T, SIZE&gt;::operator()</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> column)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordflow">if</span> (row &gt;= SIZE || column &gt;= SIZE) {</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        std::cout &lt;&lt; <span class="stringliteral">&quot;Array index out of bound, exiting&quot;</span>;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        exit(0);</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    }</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordflow">return</span> matrix[row][column];</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;}</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160; </div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00128"></a><span class="lineno"><a class="line" href="class_matrix.html#a4722df35d85e6bb1ac4666cd36063e52">  128</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_matrix.html#a4722df35d85e6bb1ac4666cd36063e52">Matrix&lt;T, SIZE&gt;::SwitchRows</a>(<a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> &amp;matrix1)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordtype">int</span> swapCounter = 0;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160; </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; SIZE; i++) {</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k = i + 1; k &lt; SIZE; k++) {</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;            <span class="keywordflow">if</span> (abs(matrix1(k, i) - matrix1(i, i)) &gt; <a class="code" href="_vector_8hh.html#a5c3c37a63ea6742bd21f87b3c482ad4d">ERR</a>) {  <span class="comment">//jesli wartosc elementu wyzej jest</span></div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;                <span class="comment">// mniejsza od elementu pod nim</span></div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;                swapCounter++;  <span class="comment">//zwieksz o jeden licznik zamian wierszy</span></div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; SIZE; j++) {</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;                    std::swap(matrix1(i, j), matrix1(k, j));  <span class="comment">//zamien dwa wiersze miejscami</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;                }</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            }</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        }</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    }</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160; </div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    <span class="keywordflow">return</span> swapCounter;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;}</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="comment"> * sprawdzenie &quot;abs(matrix1(k, i) - matrix1(i, i)) &gt; ERR&quot; nie tylko wyelminuje zera na przekatnej macierzy,</span></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="comment"> * a ustawi rowniez wiersze z mniejszymi wartosciami ponizej co ulatwi pozniej liczenie pomocniczej zmiennej w eliminacji Gaussa</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00152"></a><span class="lineno"><a class="line" href="class_matrix.html#af127708865eb29c4157be68d2d783b65">  152</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_matrix.html#af127708865eb29c4157be68d2d783b65">Matrix&lt;T, SIZE&gt;::GaussElimination</a>(<a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> &amp;matrix1)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; SIZE - 1; i++) {</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k = i + 1; k &lt; SIZE; k++) {</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            T tmp = matrix1(k, i) / matrix1(i, i);  <span class="comment">//pomocnicza zmienna do wyzerowania wiersza ponizej</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; SIZE; j++) {</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                matrix1(k, j) = matrix1(k, j) - (matrix1(i, j) * tmp);  <span class="comment">//algorytm zerujacy caly wiersz</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            }</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    }</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;}</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160; </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00164"></a><span class="lineno"><a class="line" href="class_matrix.html#ac2c8303fdc06fd4c7e292455eae5c416">  164</a></span>&#160;T <a class="code" href="class_matrix.html#ac2c8303fdc06fd4c7e292455eae5c416">Matrix&lt;T, SIZE&gt;::Determinant</a>(<a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> tmp)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    T determinant;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordtype">int</span> switchCounter = 0;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160; </div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    switchCounter = SwitchRows(tmp);</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160; </div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    GaussElimination(tmp);</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; SIZE; i++) {</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordflow">if</span> (i == 0) {</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;            determinant = tmp(i, i);</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            determinant = determinant * tmp(i, i);  <span class="comment">//przemnozenie wartosci na przekatnej macierzy</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        }</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    }</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160; </div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordflow">if</span> (switchCounter % 2 == 0) {    <span class="comment">//jesli liczba zamian wierszy jest parzysta</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        determinant = determinant;   <span class="comment">// wyznacznik pozostaje bez zmian</span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    } <span class="keywordflow">else</span> {                         <span class="comment">//jesli liczba zamian wierszy jest nieparzysta</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        determinant = -determinant;  <span class="comment">//trzeba zmienic znak wyznacznika</span></div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    }</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160; </div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="keywordflow">return</span> determinant;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;}</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160; </div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00190"></a><span class="lineno"><a class="line" href="class_matrix.html#ad5c9497d13380b10beaff841f7f5216f">  190</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_matrix.html#ad5c9497d13380b10beaff841f7f5216f">Matrix&lt;T, SIZE&gt;::Transpose</a>() {</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; SIZE; i++) {</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = i + 1; j &lt; SIZE; j++) {</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            std::swap(matrix[i][j], matrix[j][i]);</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        }</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    }</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;}</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160; </div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00199"></a><span class="lineno"><a class="line" href="class_matrix.html#aa32da33cf90c74d4a8083a08a3bf1001">  199</a></span>&#160;<a class="code" href="class_vector.html">Vector&lt;T, SIZE&gt;</a> <a class="code" href="class_matrix.html#aa32da33cf90c74d4a8083a08a3bf1001">Matrix&lt;T, SIZE&gt;::operator*</a>(<span class="keyword">const</span> <a class="code" href="class_vector.html">Vector&lt;T, SIZE&gt;</a> &amp;vector)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <a class="code" href="class_vector.html">Vector&lt;T, SIZE&gt;</a> result;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160; </div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; SIZE; ++i) {</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; SIZE; ++j) {</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;            result[i] += matrix[i][j] * vector[j];</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        }</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    }</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;}</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160; </div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00212"></a><span class="lineno"><a class="line" href="class_matrix.html#a3e08e51548e9fc339d66dcec03064d59">  212</a></span>&#160;<a class="code" href="class_matrix.html#a3e08e51548e9fc339d66dcec03064d59">Matrix&lt;T, SIZE&gt;::Matrix</a>() {</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; SIZE; ++i) {</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; SIZE; ++j) {</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            matrix[i][j] = 0;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        }</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    }</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;}</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160; </div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00221"></a><span class="lineno"><a class="line" href="_matrix_8hh.html#af58002b74adf2bdf4ee57cffba15ff6f">  221</a></span>&#160;std::istream &amp;<a class="code" href="_matrix_8hh.html#af58002b74adf2bdf4ee57cffba15ff6f">operator&gt;&gt;</a>(std::istream &amp;strm, <a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> &amp;matrix) {</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; SIZE; ++i) {</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; SIZE; ++j) {</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;            strm &gt;&gt; matrix(i, j);</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        }</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    }</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160; </div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="keywordflow">return</span> strm;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;}</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160; </div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keywordtype">int</span> SIZE&gt;</div>
<div class="line"><a name="l00232"></a><span class="lineno"><a class="line" href="_matrix_8hh.html#a329c19028ad74b9c0a93102cfecfe445">  232</a></span>&#160;std::ostream &amp;<a class="code" href="_matrix_8hh.html#a329c19028ad74b9c0a93102cfecfe445">operator&lt;&lt;</a>(std::ostream &amp;strm, <span class="keyword">const</span> <a class="code" href="class_matrix.html">Matrix&lt;T, SIZE&gt;</a> &amp;matrix) {</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; SIZE; ++i) {</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; SIZE; ++j) {</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;            strm &lt;&lt; matrix(i, j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        }</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        strm &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    }</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160; </div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    <span class="keywordflow">return</span> strm;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclass_matrix_html_ad5c9497d13380b10beaff841f7f5216f"><div class="ttname"><a href="class_matrix.html#ad5c9497d13380b10beaff841f7f5216f">Matrix::Transpose</a></div><div class="ttdeci">void Transpose()</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00190">Matrix.hh:190</a></div></div>
<div class="ttc" id="aclass_matrix_html_ac2c8303fdc06fd4c7e292455eae5c416"><div class="ttname"><a href="class_matrix.html#ac2c8303fdc06fd4c7e292455eae5c416">Matrix::Determinant</a></div><div class="ttdeci">T Determinant(Matrix&lt; T, SIZE &gt; tmp) const</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00164">Matrix.hh:164</a></div></div>
<div class="ttc" id="aclass_matrix_html_af127708865eb29c4157be68d2d783b65"><div class="ttname"><a href="class_matrix.html#af127708865eb29c4157be68d2d783b65">Matrix::GaussElimination</a></div><div class="ttdeci">void GaussElimination(Matrix&lt; T, SIZE &gt; &amp;matrix1) const</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00152">Matrix.hh:152</a></div></div>
<div class="ttc" id="a_vector_8hh_html_a5c3c37a63ea6742bd21f87b3c482ad4d"><div class="ttname"><a href="_vector_8hh.html#a5c3c37a63ea6742bd21f87b3c482ad4d">ERR</a></div><div class="ttdeci">constexpr double ERR</div><div class="ttdef"><b>Definition:</b> <a href="_vector_8hh_source.html#l00005">Vector.hh:5</a></div></div>
<div class="ttc" id="aclass_matrix_html_a8d88b4b485a4716a41159891584b0870"><div class="ttname"><a href="class_matrix.html#a8d88b4b485a4716a41159891584b0870">Matrix::operator()</a></div><div class="ttdeci">T &amp; operator()(unsigned int row, unsigned int column)</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00113">Matrix.hh:113</a></div></div>
<div class="ttc" id="aclass_matrix_html_aa32da33cf90c74d4a8083a08a3bf1001"><div class="ttname"><a href="class_matrix.html#aa32da33cf90c74d4a8083a08a3bf1001">Matrix::operator*</a></div><div class="ttdeci">Vector&lt; T, SIZE &gt; operator*(const Vector&lt; T, SIZE &gt; &amp;vector) const</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00199">Matrix.hh:199</a></div></div>
<div class="ttc" id="a_matrix_8hh_html_af58002b74adf2bdf4ee57cffba15ff6f"><div class="ttname"><a href="_matrix_8hh.html#af58002b74adf2bdf4ee57cffba15ff6f">operator&gt;&gt;</a></div><div class="ttdeci">std::istream &amp; operator&gt;&gt;(std::istream &amp;strm, Matrix&lt; T, SIZE &gt; &amp;matrix)</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00221">Matrix.hh:221</a></div></div>
<div class="ttc" id="a_matrix_8hh_html_a952eac791b596a61bba0a133a3bb439f"><div class="ttname"><a href="_matrix_8hh.html#a952eac791b596a61bba0a133a3bb439f">PI</a></div><div class="ttdeci">const double PI</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00008">Matrix.hh:8</a></div></div>
<div class="ttc" id="aclass_matrix_html_ab20a4e5f5647febc866fb32744f54f86"><div class="ttname"><a href="class_matrix.html#ab20a4e5f5647febc866fb32744f54f86">Matrix::matrix</a></div><div class="ttdeci">T matrix[SIZE][SIZE]</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00025">Matrix.hh:25</a></div></div>
<div class="ttc" id="a_vector_8hh_html"><div class="ttname"><a href="_vector_8hh.html">Vector.hh</a></div></div>
<div class="ttc" id="aclass_matrix_html_a4722df35d85e6bb1ac4666cd36063e52"><div class="ttname"><a href="class_matrix.html#a4722df35d85e6bb1ac4666cd36063e52">Matrix::SwitchRows</a></div><div class="ttdeci">int SwitchRows(Matrix&lt; T, SIZE &gt; &amp;matrix1) const</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00128">Matrix.hh:128</a></div></div>
<div class="ttc" id="a_matrix_8hh_html_a329c19028ad74b9c0a93102cfecfe445"><div class="ttname"><a href="_matrix_8hh.html#a329c19028ad74b9c0a93102cfecfe445">operator&lt;&lt;</a></div><div class="ttdeci">std::ostream &amp; operator&lt;&lt;(std::ostream &amp;strm, const Matrix&lt; T, SIZE &gt; &amp;matrix)</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00232">Matrix.hh:232</a></div></div>
<div class="ttc" id="aclass_vector_html"><div class="ttname"><a href="class_vector.html">Vector</a></div><div class="ttdef"><b>Definition:</b> <a href="_vector_8hh_source.html#l00013">Vector.hh:13</a></div></div>
<div class="ttc" id="aclass_matrix_html"><div class="ttname"><a href="class_matrix.html">Matrix</a></div><div class="ttdoc">Szablon dla klasy Matrix.</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00023">Matrix.hh:23</a></div></div>
<div class="ttc" id="aclass_matrix_html_a3e08e51548e9fc339d66dcec03064d59"><div class="ttname"><a href="class_matrix.html#a3e08e51548e9fc339d66dcec03064d59">Matrix::Matrix</a></div><div class="ttdeci">Matrix()</div><div class="ttdef"><b>Definition:</b> <a href="_matrix_8hh_source.html#l00212">Matrix.hh:212</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_0e6a83f483eb86bac30676662de98147.html">inc</a></li><li class="navelem"><a class="el" href="_matrix_8hh.html">Matrix.hh</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
